install 14 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # Mejora: tratar todos los mensajes de error desde aquí
  12. }
  13. OSInfo() {
  14. #printf "Detectando SO..."
  15. OS=$(uname -s)
  16. if [ $OS = "Linux" ]; then
  17. OS="GNU/Linux"
  18. if [ -f /etc/os-release ]; then
  19. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  20. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  21. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  22. for i in $ID_LIKE; do
  23. #printf "$i\n"
  24. case $i in
  25. debian|ubuntu)
  26. debianOS=true
  27. break
  28. ;;
  29. rhel|fedora)
  30. rhelOS=true
  31. break
  32. ;;
  33. *)
  34. debianOS=false
  35. rhelOS=false
  36. ;;
  37. esac
  38. done
  39. elif [ -f /etc/debian-version ]; then
  40. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  41. DIST="Debian"
  42. REV=""
  43. ID_LIKE="debian"
  44. debianOS=true
  45. elif [ -f /etc/redhat-release ]; then
  46. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  47. DIST="Red-Hat"
  48. REV=""
  49. ID_LIKE="rhel"
  50. rhelOS=true
  51. else
  52. # Other Linux (No Soportado)
  53. DIST=""
  54. REV=""
  55. ID_LIKE=""
  56. fi
  57. else
  58. # UNIX, OS X, ... (No Soportado)
  59. DIST=$OS
  60. REV=""
  61. fi
  62. #printf " $OS $DIST $REV\n"
  63. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  64. }
  65. comprobarRoot() {
  66. if [ $(id -u) -ne 0 ]; then
  67. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  68. exit 1
  69. fi
  70. }
  71. comprobarDependencias() {
  72. # Comprobamos whiptail
  73. which whiptail > /dev/null 2>&1
  74. if [ $? -ne 0 ];then
  75. printf "ERROR:\t'whiptail' no disponible.\n"
  76. exit 1
  77. fi
  78. # Comprobamos hostnamectl
  79. which hostnamectl > /dev/null 2>&1
  80. if [ $? -ne 0 ];then
  81. printf "ERROR:\t'hostnamectl' no disponible.\n"
  82. exit 1
  83. fi
  84. if [ $debianOS = true ];then
  85. # Comprobamos apt-get
  86. which apt-get > /dev/null 2>&1
  87. if [ $? -ne 0 ]; then
  88. printf "ERROR:\t'apt-get' no está disponible.\n"
  89. exit 1
  90. fi
  91. # Actualizamos base de datos del repositorio
  92. printf "Actualizando repositorio APT..."
  93. result=$(apt-get -q -y update)
  94. if [ $? -ne 0 ]; then
  95. printf "\nERROR:\tImposible actualizar repositorio.\n"
  96. printf "Detalles:\n$result\n"
  97. exit 1
  98. fi
  99. printf " OK.\n"
  100. # Comprobamos Firewall (ufw)
  101. which ufw > /dev/null 2>&1
  102. if [ $? -ne 0 ]; then
  103. printf "ERROR:\t'ufw' no disponible.\n"
  104. exit 1
  105. fi
  106. fi
  107. if [ $rhelOS = true ]; then
  108. # Comprobamos yum
  109. which yum > /dev/null 2>&1
  110. if [ $? -ne 0 ]; then
  111. printf "ERROR:\t'yum' no está disponible.\n"
  112. exit 1
  113. fi
  114. # Actualizamos base de datos del repositorio
  115. printf "Actualizando repositorio YUM..."
  116. result=$(yum -y makecache 2>&1)
  117. if [ $? -ne 0 ]; then
  118. printf "\nERROR:\tImposible actualizar repositorio.\n"
  119. printf "Detalles:\n$result\n"
  120. exit 1
  121. fi
  122. printf " OK.\n"
  123. # Comprobamos Firewall (firewall-cmd)
  124. which firewall-cmd > /dev/null 2>&1
  125. if [ $? -ne 0 ]; then
  126. printf "ERROR:\t'firewall-cmd' no disponible.\n"
  127. exit 1
  128. fi
  129. fi
  130. }
  131. inicializarVariables() {
  132. debianOS=false
  133. rhelOS=false
  134. apacheOn=false
  135. nginxOn=false
  136. mySQLOn=false
  137. mariaDBOn=false
  138. phpOn=false
  139. mediaWikiOn=false
  140. moodleOn=false
  141. actualizacionesOn=false
  142. }
  143. instalacionExpress() {
  144. apacheOn=true
  145. mariaDBOn=true
  146. phpOn=true
  147. mediaWikiOn=true
  148. moodleOn=true
  149. actualizacionesOn=true
  150. }
  151. mostrarBienvenida() {
  152. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  153. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --ok-button "Salir"
  154. exit 1
  155. fi
  156. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --yes-button "Continuar" --no-button "Salir"
  157. if [ $? -ne 0 ]; then
  158. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  159. exit 2
  160. fi
  161. }
  162. mostrarExpress() {
  163. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" 20 70 2 \
  164. "Express" "Instalación rápida" ON \
  165. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  166. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  167. if [ $? -ne 0 ]; then
  168. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  169. exit 2
  170. fi
  171. case $express in
  172. Express)
  173. instalacionExpress
  174. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  175. ;;
  176. Avanzada)
  177. mostrarAvanzada
  178. ;;
  179. *)
  180. printf "ERROR:\tError interno (selección express).\n"
  181. exit 1
  182. ;;
  183. esac
  184. }
  185. mostrarAvanzada() {
  186. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
  187. "WebServer" "Instalar servidor web http/https" ON \
  188. "Database" "Instalar una base de datos SQL" ON \
  189. "PHP" "Instala PHP7" ON \
  190. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  191. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  192. "Moodle" "Instalar campus virtual con Moodle" ON \
  193. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  194. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  195. if [ $? -ne 0 ]; then
  196. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  197. exit 2
  198. fi
  199. # Mejora: autodetección de componentes ya instalados
  200. for i in $componentes; do
  201. case $i in
  202. \"WebServer\")
  203. mostrarWebServer
  204. ;;
  205. \"Database\")
  206. mostrarDatabase
  207. ;;
  208. \"PHP\")
  209. phpOn=true
  210. ;;
  211. \"SSL/TLS\")
  212. # 2 Opciones: Let's Encrypt o Autofirmado
  213. ;;
  214. \"MediaWiki\")
  215. mediaWikiOn=true
  216. ;;
  217. \"Moodle\")
  218. moodleOn=true
  219. ;;
  220. \"Actualizaciones\")
  221. actualizacionesOn=true
  222. ;;
  223. *)
  224. printf "ERROR:\tError interno (selección de componentes).\n"
  225. exit 1
  226. ;;
  227. esac
  228. done
  229. }
  230. mostrarWebServer() {
  231. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  232. "Apache" "Instalar el servidor web Apache2" ON \
  233. "Nginx" "Instalar el servidor web Nginx" OFF \
  234. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  235. if [ $? -ne 0 ]; then
  236. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  237. exit 2
  238. fi
  239. case $webServer in
  240. Apache)
  241. apacheOn=true
  242. ;;
  243. Nginx)
  244. nginxOn=true
  245. ;;
  246. *)
  247. printf "ERROR:\tError interno (selección de web server).\n"
  248. exit 1
  249. ;;
  250. esac
  251. # Otras opciones (FQDN)
  252. establecerFQDN
  253. }
  254. establecerFQDN() {
  255. while [ -z $hostname ]; do
  256. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" 20 70 --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  257. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  258. hostnamectl set-hostname $hostname
  259. else
  260. hostname=$(hostname)
  261. fi
  262. done
  263. #printf "\nHostname: $hostname\n"
  264. }
  265. instalarApache() {
  266. if [ $debianOS = true ];then
  267. result=$(apt-get -q -y install apache2 2>&1)
  268. if [ $? -ne 0 ]; then
  269. printf "\nERROR:\tError al instalar Apache2.\n"
  270. printf "Detalles:\n$result\n"
  271. exit 1
  272. fi
  273. elif [ $rhelOS = true ]; then
  274. result=$(yum -y install httpd 2>&1)
  275. if [ $? -ne 0 ]; then
  276. printf "\nERROR:\tError al instalar Apache2.\n"
  277. printf "Detalles:\n$result\n"
  278. exit 1
  279. fi
  280. else
  281. printf "\nERROR:\tError interno (instalación Apache2).\n"
  282. exit 1
  283. fi
  284. }
  285. instalarNginx() {
  286. if [ $debianOS = true ];then
  287. result=$(apt-get -q -y install nginx 2>&1)
  288. if [ $? -ne 0 ]; then
  289. printf "\nERROR:\tError al instalar Nginx.\n"
  290. printf "Detalles:\n$result\n"
  291. exit 1
  292. fi
  293. elif [ $rhelOS = true ]; then
  294. # Hay que instalar primero otro repositorio
  295. result=$(yum -y install epel-release)
  296. if [ $? -ne 0 ]; then
  297. printf "\nERROR:\tError al intalar repositorio 'epel-release'.\n"
  298. printf "Detalles:\n$result\n"
  299. exit 1
  300. fi
  301. result=$(yum -y install nginx 2>&1)
  302. if [ $? -ne 0 ]; then
  303. printf "\nERROR:\tError al instalar Nginx.\n"
  304. printf "Detalles:\n$result\n"
  305. exit 1
  306. fi
  307. else
  308. printf "\nERROR:\tError interno (instalación Nginx).\n"
  309. exit 1
  310. fi
  311. }
  312. mostrarDatabase() {
  313. if [ $debianOS = true ]; then
  314. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  315. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  316. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  317. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  318. if [ $? -ne 0 ]; then
  319. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  320. exit 2
  321. fi
  322. case $database in
  323. MySQL)
  324. mySQLOn=true
  325. ;;
  326. MariaDB)
  327. mariaDBOn=true
  328. ;;
  329. *)
  330. printf "ERROR:\tError interno (selección de base de datos).\n"
  331. exit 1
  332. ;;
  333. esac
  334. elif [ $rhelOS = true ]; then
  335. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." 20 70 --yes-button "Continuar" --no-button "Salir"
  336. if [ $? -ne 0 ]; then
  337. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  338. exit 2
  339. fi
  340. mariaDBOn=true
  341. else
  342. printf "ERROR:\tError interno (instalación Base de Datos).\n"
  343. exit 1
  344. fi
  345. # Otras opciones (contraseña)
  346. leerSQLPasswd
  347. }
  348. leerSQLPasswd() {
  349. control=false
  350. # Leemos la contreseña (stdin) y confirmamos
  351. while [ $control = false ]; do
  352. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Introduzca la contraseña para el usuario 'root' de la base de datos:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  353. if [ $? -ne 0 ]; then
  354. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  355. exit 2
  356. fi
  357. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  358. if [ $? -ne 0 ];then
  359. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  360. exit 2
  361. fi
  362. if [ $sqlPasswd = $sqlPasswd2 ];then
  363. control=true
  364. fi
  365. done
  366. #printf "SQL Password: $sqlPasswd\n"
  367. unset control sqlPasswd2
  368. }
  369. establecerSQLPasswd() {
  370. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  371. }
  372. instalarMySQL() {
  373. if [ $debianOS = true ];then
  374. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  375. if [ $? -ne 0 ]; then
  376. printf "\nERROR:\tError al instalar MySQL.\n"
  377. printf "Detalles:\n$result\n"
  378. exit 1
  379. fi
  380. elif [ $rhelOS = true ]; then
  381. # MySQL no disponible en RHEL. 2 opciones:
  382. # 1) Instalar un repositorio adicional
  383. # 2) No instalar MySQL en distribuciones RHEL
  384. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  385. exit 1
  386. else
  387. printf "\nERROR:\tError interno (instalación MySQL).\n"
  388. exit 1
  389. fi
  390. }
  391. instalarMariaDB() {
  392. if [ $debianOS = true ];then
  393. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  394. if [ $? -ne 0 ]; then
  395. printf "\nERROR:\tError al instalar MariaDB.\n"
  396. printf "Detalles:\n$result\n"
  397. exit 1
  398. fi
  399. elif [ $rhelOS = true ]; then
  400. result=$(yum -y install mariadb-server 2>&1)
  401. if [ $? -ne 0 ]; then
  402. printf "\nERROR:\tError al instalar MariaDB.\n"
  403. printf "Detalles:\n$result\n"
  404. exit 1
  405. fi
  406. else
  407. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  408. exit 1
  409. fi
  410. }
  411. # Comprobación del sistema e inicialización
  412. comprobarRoot
  413. inicializarVariables
  414. OSInfo
  415. comprobarDependencias
  416. # Bienvenida
  417. mostrarBienvenida
  418. # Selección de componentes (express vs avanzada)
  419. mostrarExpress
  420. # Pre-configuración
  421. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  422. # Instalación
  423. # FALTA: whiptail --gauge -> Más bonito
  424. # Servidor Web
  425. if [ $apacheOn = true ]; then
  426. printf "Instalando Web Server Apache..."
  427. instalarApache
  428. printf " OK.\n"
  429. elif [ $nginxOn = true ]; then
  430. printf "Instalando Web Server Nginx..."
  431. instalarNginx
  432. printf " OK.\n"
  433. fi
  434. # Base de Datos
  435. if [ $mySQLOn = true ]; then
  436. printf "Instalando Base de Datos MySQL..."
  437. instalarMySQL
  438. printf " OK.\n"
  439. elif [ $mariaDBOn = true ]; then
  440. printf "Instalando Base de Datos MariaDB..."
  441. instalarMariaDB
  442. printf " OK.\n"
  443. fi
  444. # PHP
  445. if [ $phpOn = true ]; then
  446. printf "Instalando PHP-7..."
  447. printf " OK.\n"
  448. fi
  449. # SSL/TLS
  450. # Falta por implementar
  451. # MediaWiki
  452. if [ $mediaWikiOn = true ]; then
  453. printf "Instalando MediaWiki..."
  454. printf " OK.\n"
  455. fi
  456. # Moodle
  457. if [ $moodleOn = true ]; then
  458. printf "Instalando Moodle..."
  459. printf " OK.\n"
  460. fi
  461. # Configuración
  462. # Configuración Apache
  463. # Virtual Hosts
  464. # Configuración Database
  465. # Establecer Contrasñea y configuración Segura
  466. if [ $mySQLOn = true ] || [ $mariaDBOn = true ];then
  467. establecerSQLPasswd
  468. fi
  469. # Configuración PHP
  470. # cgi.fix_pathinfo=0
  471. # Configurar máximo de subida de archivos
  472. # Configuración MediWiki
  473. # Configuración Moodle
  474. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  475. # Añadir reglas del cortafuegos
  476. # Configuración SSL/TLS
  477. # Generar certificados
  478. # Configurar certificados
  479. # Configurar actualizaciones
  480. if [ $actualizacionesOn = true ]; then
  481. printf "Configurando actualizaciones automáticas..."
  482. # CRONTAB
  483. printf " OK.\n"
  484. fi
  485. # Autodestrucción
  486. {
  487. for i in $(seq 0 5 50); do
  488. sleep 0.1
  489. echo $i
  490. done
  491. } | whiptail --gauge "Autodestrucción..." 7 70 0
  492. {
  493. for i in $(seq 50 5 100); do
  494. sleep 0.1
  495. echo $i
  496. done
  497. } | whiptail --gauge "Autopulverización..." 7 70 50